import json
import urllib2


class Account(object):

    def __init__(self, name):
        self.name = name

    def _root_url(self):
        return "http://%s.leankitkanban.com" % self.name

    def _open(self, request, username, password):
        manager = urllib2.HTTPPasswordMgrWithDefaultRealm()
        manager.add_password(None, self._root_url(), username, password)
        handler = urllib2.HTTPBasicAuthHandler(manager)
        opener = urllib2.build_opener(handler)
        return opener.open(request)

    def _boards_url(self):
        return "%s/Kanban/Api/Boards" % self._root_url()

    def _board_url(self, board):
        return "%s/Kanban/Api/Board/%s/GetBoardIdentifiers" % (self._root_url(), board)

    def info(self, username, password):
        request = urllib2.Request(self._boards_url())
        response = self._open(request, username, password)
        j = json.load(response)
        return j["ReplyData"][0]


class Board(object):

    def __init__(self, account, id):
        self.account = account
        self.id = id

    def info(self, username, password):
        request = urllib2.Request(self.account._board_url(self.id))
        response = self.account._open(request, username, password)
        j = json.load(response)
        return j["ReplyData"][0]
